﻿
Public Class F_カレンダー

    ' 複数ラジオボタンを変数として宣言
    Public Shared chkParty() As RadioButton

    '前日祝日flg 振替休日判定用
    Public b_hday_flg As String

    Private Sub F_カレンダー_Load(sender As Object, e As EventArgs) Handles MyBase.Load

        ' ラベルに入れるテキストを作成
        Dim lstOutText As List(Of String)
        lstOutText = New List(Of String)({"日", "月", "火", "水", "木", "金", "土"})

        ' ラベル軍団を変数として宣言
        Dim labelParty() As System.Windows.Forms.Label

        ' インスタンスを作成
        labelParty = New System.Windows.Forms.Label() _
            {Me.曜日1, Me.曜日2, Me.曜日3, Me.曜日4, Me.曜日5, Me.曜日6, Me.曜日7}

        chkParty = New System.Windows.Forms.RadioButton() _
           {Me.D01, Me.D02, Me.D03, Me.D04, Me.D05, Me.D06, Me.D07 _
              , Me.D08, Me.D09, Me.D10, Me.D11, Me.D12, Me.D13, Me.D14 _
             , Me.D15, Me.D16, Me.D17, Me.D18, Me.D19, Me.D20, Me.D21 _
             , Me.D22, Me.D23, Me.D24, Me.D25, Me.D26, Me.D27, Me.D28 _
             , Me.D29, Me.D30, Me.D31, Me.D32, Me.D33, Me.D34, Me.D35 _
              , Me.D36, Me.D37, Me.D38, Me.D39, Me.D40, Me.D41, Me.D42
         }


        ' ラベル軍団に値を入れていく
        For i As Integer = 0 To labelParty.Count - 1
            labelParty(i).Text = lstOutText(i)

            Select Case lstOutText(i)
                Case "日"
                    labelParty(i).ForeColor = Color.Red
                Case "土"
                    labelParty(i).ForeColor = Color.Blue
                Case Else
                    labelParty(i).ForeColor = Color.Black
            End Select

        Next

        '年コンボに値セット

        ' --- 日付表示 ---
        Dim dsp_day As Date
        If cal.p_ymd = Nothing Then
            dsp_day = DateTime.Now                                    '今日
        Else
            dsp_day = cal.p_ymd
        End If

        Me.年.Text = dsp_day.ToString("yyyy")
        Me.月.Text = dsp_day.ToString("MM")
        Me.日.Text = dsp_day.ToString("dd")

        日付表示(dsp_day)


    End Sub

    Public Sub 日付表示(d As DateTime)

        Dim w_indate As Date = d

        Me.年.Text = w_indate.ToString("yyyy")
        Dim Y As Integer = Val(Me.年.Text)
        Me.月.Text = w_indate.ToString("MM")
        Me.日.Text = w_indate.ToString("dd")
        Dim firstDayOfMonth = New DateTime(w_indate.Year, w_indate.Month, 1)      '今月1日
        Dim BaseDate As Date
        Dim w_n As Integer

        BaseDate = FirstDayOfThisWeek(firstDayOfMonth)                          '１日の週の日曜日の日付

        Dim w_date As Date = BaseDate

        b_hday_flg = "0"

        'ラジオボタン軍団に日付を入れていく
        For i As Integer = 0 To chkParty.Count - 1
            '第何週か
            w_n = Int((w_date.Day + 6) / 7)

            chkParty(i).Text = w_date.Day.ToString("d")
            chkParty(i).Checked = False
            ToolTip1.SetToolTip(chkParty(i), "")

            Select Case w_date.DayOfWeek
                Case DayOfWeek.Sunday
                    chkParty(i).ForeColor = Color.Red
                Case DayOfWeek.Saturday
                    chkParty(i).ForeColor = Color.Blue
                Case Else
                    chkParty(i).ForeColor = Color.Black
            End Select

            If w_indate.ToString("MM") <> w_date.ToString("MM") Then
                chkParty(i).ForeColor = Color.FromArgb(128, 128, 128)
                GoTo L100
            End If

            If w_indate.ToString("yyyy/MM/dd") = w_date.ToString("yyyy/MM/dd") Then
                chkParty(i).Checked = True
                chkParty(i).Select()
            End If

            If b_hday_flg = "1" Then
                chkParty(i).ForeColor = Color.Red
                ToolTip1.SetToolTip(chkParty(i), "振替休日")
                b_hday_flg = "0"
                GoTo L100
            End If

            '--- 祝日判定 -----
            Select Case w_date.Month
                Case 1
                    If w_date.Day = 1 Then
                        Call SetHoliday(w_date, i, "元旦", 0, True)
                    End If

                    If Y < 2000 And w_date.Day = 15 Then
                        Call SetHoliday(w_date, i, "成人の日", 0, True)
                    End If

                    If Y >= 2000 And w_n = 2 And w_date.DayOfWeek = 1 Then
                        Call SetHoliday(w_date, i, "成人の日", 0, True)
                    End If

                Case 2
                    If w_date.Day = 11 Then
                        Call SetHoliday(w_date, i, "建国記念の日", 0, True)
                    End If
                    If Y >= 2020 And w_date.Day = 23 Then
                        Call SetHoliday(w_date, i, "天皇誕生日", 0, True)
                    End If

                Case 3
                    If w_date.Day = Int(20.8431 + 0.242194 * (Y - 1980) - ((Y - 1980) \ 4)) Then
                        Call SetHoliday(w_date, i, "春分の日", 0, True)
                    End If

                Case 4
                    If w_date.Day = 29 Then
                        Call SetHoliday(w_date, i, "昭和の日", 0, True)
                    End If

                Case 5
                    Select Case w_date.Day
                        Case 3
                            Call SetHoliday(w_date, i, "憲法記念の日", 0, True)
                        Case 4
                            Call SetHoliday(w_date, i, "みどりの日", 0, True)
                            If Y >= 2014 Then
                                If Format(w_date, "aaa") = "日" Then
                                    Call SetHoliday(w_date.AddDays(2), i, "みどりの日の振替", 0, False)
                                End If
                            End If

                        Case 5
                            Call SetHoliday(w_date, i, "こどもの日", 0, True)
                    End Select

                Case 7
                    If Y < 2003 And w_date.Day = 20 Then
                        Call SetHoliday(w_date, i, "海の日", 0, True)
                    End If

                    If Y >= 2003 And w_n = 3 And w_date.DayOfWeek = 1 Then
                        Call SetHoliday(w_date, i, "海の日", 0, False)
                    End If

                Case 8
                    If Y >= 2016 And w_date.Day = 11 Then
                        Call SetHoliday(w_date, i, "山の日", 0, True)
                    End If

                Case 9

                    If Y < 2003 And w_date.Day = 15 Then
                        Call SetHoliday(w_date, i, "敬老の日", 0, True)
                    End If
                    If Y >= 2003 And w_n = 3 And w_date.DayOfWeek = 1 Then
                        Call SetHoliday(w_date, i, "敬老の日", 0, False)
                    End If

                    If w_date.Day = Int(23.2488 + 0.242194 * (Y - 1980) - ((Y - 1980) \ 4)) Then
                        Call SetHoliday(w_date, i, "秋分の日", 0, True)
                    End If

                Case 10
                    If Y < 2000 And w_date.Day = 10 Then
                        Call SetHoliday(w_date, i, "体育の日", 0, True)
                    End If
                    If Y >= 2000 And w_n = 2 And w_date.DayOfWeek = 1 Then
                        Call SetHoliday(w_date, i, "スポーツの日", 0, False)
                    End If

                Case 11
                    If w_date.Day = 3 Then
                        Call SetHoliday(w_date, i, "文化の日", 0, True)
                    End If
                    If w_date.Day = 23 Then
                        Call SetHoliday(w_date, i, "勤労感謝の日", 0, True)
                    End If

                Case 12
                    If Y < 2019 And Y >= 1989 And w_date.Day = 23 Then
                        Call SetHoliday(w_date, i, "天皇誕生日", 0, True)
                    End If


            End Select

L100:
            '--- 次の日へ ---
            w_date = w_date.AddDays(1)

        Next


    End Sub

    Public Sub SetHoliday(indate As Date, nDay As Integer, sname As String, nColor As Long, bFurikae As Boolean)

        chkParty(nDay).ForeColor = Color.Red
        ToolTip1.SetToolTip(chkParty(nDay), sname)

        '--- 振替休日判定 祝日が日曜日なら月曜日が振替休日
        If bFurikae And indate.ToString("ddd") = "日" Then
            b_hday_flg = "1"
            Exit Sub
        End If

    End Sub


    ' 日曜日始まりの場合の日付
    Public Shared Function FirstDayOfThisWeek(d As DateTime) As DateTime
        Return d.AddDays(DayOfWeek.Sunday - d.DayOfWeek)
    End Function


    Private Sub btn_前月_Click(sender As Object, e As EventArgs) Handles btn_前月.Click
        ' --- 前月表示 ---
        Dim w_date As Date

        Call selday_set()           '選択された日を取得

        w_date = chk_day(CDate(Me.年.Text & "/" & Me.月.Text & "/01").AddMonths(-1).ToString("yyyy/MM") & "/" & Me.日.Text)

        日付表示(w_date)

    End Sub

    Private Sub btn_次月_Click(sender As Object, e As EventArgs) Handles btn_次月.Click
        ' --- 次月表示 ---
        Dim w_date As Date

        Call selday_set()           '選択された日を取得

        w_date = chk_day(CDate(Me.年.Text & "/" & Me.月.Text & "/01").AddMonths(1).ToString("yyyy/MM") & "/" & Me.日.Text)
        日付表示(w_date)

    End Sub

    Private Sub btn_OK_Click(sender As Object, e As EventArgs) Handles btn_OK.Click
        Dim w_str As String
        Dim w_selday As String = ""

        Call selday_set()           '選択された日を取得

        w_str = 年.Text & "/" & 月.Text & "/" & 日.Text

        'MessageBox.Show(w_str)
        cal.p_ymd = CDate(w_str)

        'OKボタンが押された時はDialogResult.OKを設定する。
        Me.DialogResult = System.Windows.Forms.DialogResult.OK

        Me.Close()

    End Sub

    Private Sub btn_cancel_Click(sender As Object, e As EventArgs) Handles btn_cancel.Click

        cal.p_ymd = Nothing

        'キャンセルボタンが押された時はDialogResult.Cancelを設定する。
        Me.DialogResult = System.Windows.Forms.DialogResult.Cancel

        Me.Close()

    End Sub

    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles Button1.Click
        ' --- 次年表示 ---
        Dim w_date As Date

        Call selday_set()           '選択された日を取得

        w_date = chk_day(CDate(Me.年.Text & "/" & Me.月.Text & "/01").AddYears(1).ToString("yyyy/MM") & "/" & Me.日.Text)
        日付表示(w_date)

    End Sub

    Private Sub Button2_Click(sender As Object, e As EventArgs) Handles Button2.Click
        ' --- 前年表示 ---
        Dim w_date As Date

        Call selday_set()           '選択された日を取得

        w_date = chk_day(CDate(Me.年.Text & "/" & Me.月.Text & "/01").AddYears(-1).ToString("yyyy/MM") & "/" & Me.日.Text)
        日付表示(w_date)

    End Sub

    Private Sub D01_Click(sender As Object, e As EventArgs) Handles D01.Click
        '前月分クリックなら前月表示
        If D01.ForeColor <> Color.FromArgb(128, 128, 128) Then
            Exit Sub
        End If

        Call bmm_dsp()              '前月表示

    End Sub

    Public Function chk_day(in_str As String) As Date
        Dim w_yy As String
        Dim w_mm As String
        Dim w_dd As String

        If IsDate(in_str) Then
            chk_day = CDate(in_str)
            Return chk_day
        End If

        w_yy = Mid(in_str, 1, 4)
        w_mm = Mid(in_str, 6, 2)
        w_dd = Mid(in_str, 9, 2)

        chk_day = CDate(w_yy & "/" & w_mm & "/01").AddMonths(1).AddDays(-1)

        Return chk_day

    End Function

    Public Sub selday_set()
        '選択された日付を日.textにセット
        '日付（GroupBox1）の選択項目を取得
        For Each rdoday As RadioButton In GroupBox1.Controls
            If rdoday.Checked Then
                日.Text = rdoday.Text
                Exit For
            End If
        Next

    End Sub


    Public Sub bmm_dsp()
        '前月
        Call selday_set()           '選択された日を取得

        Dim w_date As Date
        w_date = chk_day(CDate(Me.年.Text & "/" & Me.月.Text & "/01").AddMonths(-1).ToString("yyyy/MM") & "/" & Me.日.Text)
        日付表示(w_date)

    End Sub
    Public Sub nmm_dsp()
        '次月
        Call selday_set()           '選択された日を取得

        Dim w_date As Date
        w_date = chk_day(CDate(Me.年.Text & "/" & Me.月.Text & "/01").AddMonths(1).ToString("yyyy/MM") & "/" & Me.日.Text)
        日付表示(w_date)

    End Sub



    Private Sub D36_Click(sender As Object, e As EventArgs) Handles D36.Click
        '次月分クリックなら次月表示
        If D36.ForeColor <> Color.FromArgb(128, 128, 128) Then
            Exit Sub
        End If

        Call nmm_dsp()              '次月月表示
    End Sub

    Private Sub D02_Click(sender As Object, e As EventArgs) Handles D02.Click
        '前月分クリックなら前月表示
        If D02.ForeColor <> Color.FromArgb(128, 128, 128) Then
            Exit Sub
        End If

        Call bmm_dsp()              '前月表示

    End Sub

    Private Sub D03_Click(sender As Object, e As EventArgs) Handles D03.Click
        '前月分クリックなら前月表示
        If D03.ForeColor <> Color.FromArgb(128, 128, 128) Then
            Exit Sub
        End If

        Call bmm_dsp()              '前月表示

    End Sub

    Private Sub D04_Click(sender As Object, e As EventArgs) Handles D04.Click
        '前月分クリックなら前月表示
        If D04.ForeColor <> Color.FromArgb(128, 128, 128) Then
            Exit Sub
        End If

        Call bmm_dsp()              '前月表示

    End Sub

    Private Sub D05_Click(sender As Object, e As EventArgs) Handles D05.Click
        '前月分クリックなら前月表示
        If D05.ForeColor <> Color.FromArgb(128, 128, 128) Then
            Exit Sub
        End If

        Call bmm_dsp()              '前月表示

    End Sub

    Private Sub D06_Click(sender As Object, e As EventArgs) Handles D06.Click
        '前月分クリックなら前月表示
        If D06.ForeColor <> Color.FromArgb(128, 128, 128) Then
            Exit Sub
        End If

        Call bmm_dsp()              '前月表示

    End Sub

    Private Sub D07_Click(sender As Object, e As EventArgs) Handles D07.Click
        '前月分クリックなら前月表示
        If D07.ForeColor <> Color.FromArgb(128, 128, 128) Then
            Exit Sub
        End If

        Call bmm_dsp()              '前月表示

    End Sub

    Private Sub D37_CheckedChanged(sender As Object, e As EventArgs)
    End Sub

    Private Sub D37_Click(sender As Object, e As EventArgs) Handles D37.Click
        '次月分クリックなら次月表示
        If D37.ForeColor <> Color.FromArgb(128, 128, 128) Then
            Exit Sub
        End If

        Call nmm_dsp()              '次月表示

    End Sub

    Private Sub D38_Click(sender As Object, e As EventArgs) Handles D38.Click
        '次月分クリックなら次月表示
        If D38.ForeColor <> Color.FromArgb(128, 128, 128) Then
            Exit Sub
        End If

        Call nmm_dsp()              '次月表示

    End Sub

    Private Sub D39_Click(sender As Object, e As EventArgs) Handles D39.Click
        '次月分クリックなら次月表示
        If D39.ForeColor <> Color.FromArgb(128, 128, 128) Then
            Exit Sub
        End If

        Call nmm_dsp()              '次月表示

    End Sub

    Private Sub D40_Click(sender As Object, e As EventArgs) Handles D40.Click
        '次月分クリックなら次月表示
        If D40.ForeColor <> Color.FromArgb(128, 128, 128) Then
            Exit Sub
        End If

        Call nmm_dsp()              '次月表示

    End Sub

    Private Sub D41_Click(sender As Object, e As EventArgs) Handles D41.Click
        '次月分クリックなら次月表示
        If D41.ForeColor <> Color.FromArgb(128, 128, 128) Then
            Exit Sub
        End If

        Call nmm_dsp()              '次月表示

    End Sub

    Private Sub D42_Click(sender As Object, e As EventArgs) Handles D42.Click
        '次月分クリックなら次月表示
        If D42.ForeColor <> Color.FromArgb(128, 128, 128) Then
            Exit Sub
        End If

        Call nmm_dsp()              '次月表示

    End Sub
End Class