﻿Imports System.Collections.ObjectModel
Imports System.Data.Odbc
Imports System.Text

Public Class F_参照
    Public con_str As String = ""
    Public acfile As String = ""

    Private Sub F_参照_Load(sender As Object, e As EventArgs) Handles MyBase.Load

        Call form_ini()

        Call Conb_ini()

    End Sub
    Private Sub form_ini()
        Dim w_sql As String

        Me.KeyPreview = True        'キーボードイベント取得

        Try
            '※ODBC接続文字列取得
            Dim sb1_1 As StringBuilder = New StringBuilder(300)
            Dim unused = common.GetPrivateProfileString("ODBC", "conn", "none", sb1_1, Convert.ToUInt32(sb1_1.Capacity), ".\eform.ini")
            If sb1_1.ToString <> "" Then
                con_str = sb1_1.ToString
            End If

            'Accessファイル
            Dim sb1_2 As StringBuilder = New StringBuilder(300)
            common.GetPrivateProfileString("ODBC", "acfile", "none", sb1_2, Convert.ToUInt32(sb1_2.Capacity), ".\eform.ini")
            If sb1_2.ToString <> "" Then
                acfile = sb1_2.ToString
            End If

            If con_str = "" And acfile <> "" Then
                con_str = "Driver={Microsoft Access Driver (*.mdb, *.accdb)};DBQ=" & acfile & "; Uid=; Pwd =;"
            End If

        Catch ex As Exception
            MessageBox.Show(Err.Description)
            Close()
            'Return
        End Try

        Try
            Using Conn As New OdbcConnection(con_str)

                'DB接続
                Conn.Open()

                'コントロールテーブル参照
                w_sql = "SELECT * FROM ef_cnt_tbl"

                ' 読み込み
                Dim oc = New OdbcCommand(w_sql, Conn)
                Dim odr = oc.ExecuteReader()
                While odr.Read() = True

                    Me.Text = "入力済参照 - " & odr("syamei").ToString

                    '背景色 Access側 10進数からRGB算出
                    Dim w_color = odr("bcolor")
                    Dim w_blue = Math.Truncate(w_color / 65536)
                    Dim w_green = Math.Truncate((w_color - 65536 * w_blue) / 256)
                    Dim w_red = w_color - (65536 * w_blue) - (256 * w_green)
                    Me.BackColor = Color.FromArgb(w_red, w_green, w_blue)

                End While

                odr.Close()
                oc.Dispose()

            End Using

        Catch ex As Exception
            MessageBox.Show(Err.Description)
            Close()
            'Return
        End Try

    End Sub

    Private Sub Conb_ini()
        '--- 取引先名コンボのソースをeform_info_dのデータよりセット ---
        Dim w_sql As String
        Dim dt As DataTable
        Dim adapter As OdbcDataAdapter

        Try
            Using Conn As New OdbcConnection(con_str)
                'DB接続
                Conn.Open()
                ' --- 取引先名 -----
                w_sql = "SELECT torinm FROM eform_info_d WHERE torinm <>'' AND sysskbn<>'削除' "
                w_sql &= " GROUP BY torinm ORDER BY torinm"
                w_sql &= ";"
                dt = New DataTable()

                '// 読み込み
                adapter = New OdbcDataAdapter(w_sql, Conn)
                adapter.Fill(dt)

                取引先名.DataSource = dt    '// 取引先名コンボソース

                adapter.Dispose()

                'データ用の列を設定
                取引先名.ValueMember = "torinm"
                取引先名.Text = ""

            End Using

        Catch ex As Exception
            MessageBox.Show(Err.Description)
            'Close()
            Return
        End Try

    End Sub

    Private Sub Btn_検索_Click(sender As Object, e As EventArgs) Handles Btn_検索.Click
        Dim w_sql As String

        Try
            Using Conn As New OdbcConnection(con_str)

                ListView1.Clear()
                ListView1.FullRowSelect = True
                ListView1.GridLines = True

                '01．ListView にアイテム及びサブアイテムを追加する
                With ListView1
                    .View = View.Details
                    'ヘッダー部の追加(左寄せで表示)
                    'ヘッダー部のテキストの配置を設定
                    .Columns.Add("No", 40, HorizontalAlignment.Left)
                    .Columns.Add("取引日", 100, HorizontalAlignment.Left)
                    .Columns.Add("取引先名", 160, HorizontalAlignment.Left)
                    .Columns.Add("支払先名", 140, HorizontalAlignment.Left)
                    .Columns.Add("金額", 80, HorizontalAlignment.Center)
                End With

                'DB接続
                Conn.Open()

                ' --- 取引先名 -----
                w_sql = "SELECT * FROM eform_info_d WHERE torinm Like '%" & 取引先名.Text & "%' "
                w_sql &= " ORDER BY ymd Desc,rno"
                w_sql &= ";"

                Dim i As Integer = 0

                ' 読み込み
                Dim oc = New OdbcCommand(w_sql, Conn)
                Dim odr = oc.ExecuteReader()

                While odr.Read() = True

                    With ListView1

                        'アイテムを追加
                        .Items.Add(odr("rno").ToString, i)
                        'サブアイテムを追加
                        .Items(i).SubItems.Add(odr("ymd").ToString)
                        .Items(i).SubItems.Add(odr("torinm").ToString)
                        .Items(i).SubItems.Add(odr("sihanm").ToString)
                        .Items(i).SubItems.Add(Format(CDbl(odr("kin")), "#,##0"))

                    End With

                    i += 1

                End While

                odr.Close()
                oc.Dispose()

            End Using

        Catch ex As Exception
            MessageBox.Show(Err.Description)
            'Close()
            Return
        End Try

    End Sub

    Private Sub btn_キャンセル_Click(sender As Object, e As EventArgs) Handles btn_キャンセル.Click

        'キャンセルボタンが押された時はDialogResult.Cancelを設定する。
        Me.DialogResult = System.Windows.Forms.DialogResult.Cancel

        Close()

    End Sub

    Private Sub btn_確定_Click(sender As Object, e As EventArgs) Handles btn_確定.Click
        '選択されている項目を取得する
        For Each si As ListViewItem In ListView1.SelectedItems
            Dim subItem0 As String = si.SubItems(0).Text
            Dim subItem1 As String = si.SubItems(1).Text
            Dim subItem2 As String = si.SubItems(2).Text
            Dim myDat As String = String.Format("Index = {0}   Item(0) = {1}   Item(1) = {2}   Item(2) = {3}",
                                                 si.Index, subItem0, subItem1, subItem2)
            'MessageBox.Show(myDat)
            Debug.WriteLine(si.Index)
            Debug.WriteLine(subItem0)
            Debug.WriteLine(subItem1)
            Debug.WriteLine(subItem2)

            common.p_no = subItem0

            'OKボタンが押された時はDialogResult.OKを設定する。
            Me.DialogResult = System.Windows.Forms.DialogResult.OK

            Close()

        Next
    End Sub

    Private Sub ListView1_DoubleClick(sender As Object, e As EventArgs) Handles ListView1.DoubleClick
        '選択されていない場合
        If ListView1.SelectedItems.Count = 0 Then
            Exit Sub
        End If

        btn_確定.PerformClick()
    End Sub

    Private Sub F_参照_KeyDown(sender As Object, e As KeyEventArgs) Handles MyBase.KeyDown
        Dim forward As Boolean

        If e.KeyCode = Keys.Enter Then
            ' Shiftキーが押されているかの判定
            forward = e.Modifiers <> Keys.Shift
            ' タブオーダー順で次のコントロールにフォーカスを移動
            Me.SelectNextControl(Me.ActiveControl, forward, True, True, True)
        End If

    End Sub

    Private Sub F_参照_KeyPress(sender As Object, e As KeyPressEventArgs) Handles MyBase.KeyPress
        If e.KeyChar = ControlChars.Cr Then
            '[Enter]キーで音が出るので、キーイベントが処理されたことにして音を消す
            e.Handled = True
        End If
    End Sub
End Class