﻿Imports System.Data.Odbc
Imports System.Text

Public Class start
    Public con_str As String = ""
    Public acfile As String = ""

    Private Sub start_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Dim w_sql As String
        Dim res As String

        Try
            '※ODBC接続文字列取得
            Dim sb1_1 As StringBuilder = New StringBuilder(300)
            Dim unused = common.GetPrivateProfileString("ODBC", "conn", "none", sb1_1, Convert.ToUInt32(sb1_1.Capacity), ".\eform.ini")
            If sb1_1.ToString <> "" Then
                con_str = sb1_1.ToString
            End If

            'Accessファイル
            Dim sb1_2 As StringBuilder = New StringBuilder(300)
            common.GetPrivateProfileString("ODBC", "acfile", "none", sb1_2, Convert.ToUInt32(sb1_2.Capacity), ".\eform.ini")
            If sb1_2.ToString <> "" Then
                acfile = sb1_2.ToString
            End If

            If con_str = "" And acfile <> "" Then
                con_str = "Driver={Microsoft Access Driver (*.mdb, *.accdb)};DBQ=" & acfile & "; Uid=; Pwd =;"
            End If

        Catch ex As Exception
            MessageBox.Show(Err.Description)
            'Close()
            'Return
            res = MsgBox("接続設定を確認してください。", vbExclamation)
        End Try

        If con_str = Nothing Then
            res = MsgBox("接続を設定してください。", vbExclamation)
            'Close()

            Dim fs As Form = New F_設定()
            fs.ShowDialog()


        Else
            Try
                Using Conn As New OdbcConnection(con_str)

                    'DB接続
                    Conn.Open()

                    'コントロールテーブル参照
                    w_sql = "SELECT * FROM ef_cnt_tbl"

                    ' 読み込み
                    Dim oc = New OdbcCommand(w_sql, Conn)
                    Dim odr = oc.ExecuteReader()
                    While odr.Read() = True

                        Me.Text = "電子帳票管理 - " & odr("syamei").ToString

                        '背景色 Access側 10進数からRGB算出
                        Dim w_color = odr("bcolor")
                        Dim w_blue = Math.Truncate(w_color / 65536)
                        Dim w_green = Math.Truncate((w_color - 65536 * w_blue) / 256)
                        Dim w_red = w_color - (65536 * w_blue) - (256 * w_green)
                        Me.BackColor = Color.FromArgb(w_red, w_green, w_blue)

                    End While

                    odr.Close()
                    oc.Dispose()

                End Using

            Catch ex As Exception
                MessageBox.Show(Err.Description)
                'Close()
                'Return
                res = MsgBox("接続設定を確認してください。", vbExclamation)
            End Try

        End If

    End Sub

    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles Button1.Click
        '重複起動防止
        If common.p_form1_flg = True Then
            Exit Sub
        End If

        Dim f1 As Form = New Form1()
        'f1.ShowDialog()
        f1.Show()
        common.p_form1_flg = True

    End Sub

    Private Sub Button2_Click(sender As Object, e As EventArgs) Handles Button2.Click
        '重複起動防止
        If common.p_form2_flg = True Then
            Exit Sub
        End If

        Dim f2 As Form = New Form2()
        'f2.ShowDialog()
        f2.Show()
        common.p_form2_flg = True

    End Sub

    Private Sub Button3_Click(sender As Object, e As EventArgs) Handles Button3.Click

        Close()

    End Sub

    Private Sub btn_設定_Click(sender As Object, e As EventArgs) Handles btn_設定.Click
        Dim fs As Form = New F_設定()
        fs.ShowDialog()

    End Sub

    Private Sub Button4_Click(sender As Object, e As EventArgs) Handles Button4.Click
        Dim fs As Form = New F_初期設定()
        fs.ShowDialog()

    End Sub
End Class