﻿Imports System.Text

Public Class F_設定
    Private Sub cmd_ファイル選択_Click(sender As Object, e As EventArgs) Handles cmd_ファイル選択.Click
        ' ダイアログボックスの表示
        OpenFileDialog1.Filter = "Microsoft Access|*.accdb"
        If OpenFileDialog1.ShowDialog() = System.Windows.Forms.DialogResult.OK Then
            '// 選択されたファイルをテキストボックスに表示する
            ファイル名.Text = OpenFileDialog1.FileName
        End If
    End Sub

    Private Sub F_設定_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Dim sb1_1 As StringBuilder = New StringBuilder(300)
        Dim sb1_2 As StringBuilder = New StringBuilder(300)

        'ODBC DSN取得
        common.GetPrivateProfileString("ODBC", "conn", "none", sb1_1, Convert.ToUInt32(sb1_1.Capacity), ".\\eform.ini")
        DSN名.Text = sb1_1.ToString

        'AccessFile 取得
        common.GetPrivateProfileString("ODBC", "acfile", "none", sb1_2, Convert.ToUInt32(sb1_2.Capacity), ".\\eform.ini")
        ファイル名.Text = sb1_2.ToString

    End Sub

    Private Sub btn_書込み_Click(sender As Object, e As EventArgs) Handles btn_書込み.Click
        Dim res As String
        Dim iniFileName As New StringBuilder(300)

        If ファイル名.Text <> "" Then
            If Dir(ファイル名.Text) = "" Then
                res = MsgBox("Accessファイルが存在しません。確認してください。", vbExclamation)
                Exit Sub
            End If
        End If

        iniFileName.Append(".\\eform.ini")
        common.WritePrivateProfileString("ODBC", "conn", DSN名.Text, iniFileName)
        common.WritePrivateProfileString("ODBC", "acfile", ファイル名.Text, iniFileName)

        res = MsgBox("書き込みました。", vbInformation)

        Me.Close()

    End Sub

    Private Sub cmd_キャンセル_Click(sender As Object, e As EventArgs) Handles cmd_キャンセル.Click

        Close()

    End Sub
End Class